Bug 1827948 (python-spyking-circus) - Review Request: python-spyking-circus - Fast and scalable spike sorting of large-scale extracellular recordings
Summary: Review Request: python-spyking-circus - Fast and scalable spike sorting of la...
Keywords:
Status: CLOSED ERRATA
Alias: python-spyking-circus
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: greg.hellings
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2020-04-25 19:28 UTC by Ankur Sinha (FranciscoD)
Modified: 2020-05-06 04:29 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-06 03:07:25 UTC
Type: ---
greg.hellings: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2020-04-25 19:28:46 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-spyking-circus/python-spyking-circus.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-spyking-circus/python-spyking-circus-0.9.7-1.fc32.src.rpm

Description:
SpyKING CIRCUS is a python code to allow fast spike sorting on multi channel
recordings. A publication on the algorithm can be found at
https://elifesciences.org/articles/34518.

It has been tested on datasets coming from in vitro retina with 252 electrodes
MEA, from in vivo hippocampus with tetrodes, in vivo and in vitro cortex data
with 30 and up to 4225 channels, with good results. Synthetic tests on these
data show that cells firing at more than 0.5Hz can be detected, and their
spikes recovered with error rates at around 1%, even resolving overlapping
spikes and synchronous firing. It seems to be compatible with optogenetic
stimulation, based on experimental data obtained in the retina.

Fedora Account System Username: ankursinha

Comment 1 david08741 2020-04-25 20:24:58 UTC
I tried to build the package, but that failed to print without ()

Is this using python2?

Also, why are the tests disabled?
MPI is available ...

COPR build: https://copr.fedorainfracloud.org/coprs/davidsch/testing/package/python-spyking-circus/

Comment 2 greg.hellings 2020-04-26 04:25:01 UTC
I'll hop on this review

Comment 3 greg.hellings 2020-04-26 05:05:49 UTC
tl;dr My test machine is running Fedora 31, and I tested in F32 in a container. I couldn't get the package to install. Two other oddities that need an explanation or quick correction.

If you've got a minute, I could use a quick review on https://bugzilla.redhat.com/show_bug.cgi?id=1827887 as well.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly. Fails to install with error "nothing provides python3.8dist(mpi4py) needed by python3-spyking-circus-0.9.7-1.fc32.noarch"
- There are odd provides being picked up by rpmlint. python- and python38-.
  The python38- seems like it's targeting EPEL, while the bare python-
  doesn't seem right. But those must be auto-generated by the macros you
  use, as there are no explicit "provides" listed
- README.rst is listed as %license but appears to be more of a README. This
  gives two files listed as license files

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "CeCILL License 2.1", "CeCILL License
     (v2.1)", "*No copyright* CeCILL License (v2.1)". 198 files have
     unknown license. Detailed output of licensecheck in
     /home/ghelling/src/packaging/1827948-python-spyking-
     circus/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: python3-spyking-circus (description)
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[!]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-spyking-circus
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 2.2 starting (python version = 3.7.6)...
Start: init plugins
INFO: selinux disabled
Finish: init plugins
INFO: Signal handler active
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled package manager cache
Start: cleaning package manager metadata
Finish: cleaning package manager metadata
INFO: enabled HW Info plugin
Mock Version: 2.2
INFO: Mock Version: 2.2
Finish: chroot init
INFO: installing package(s): /home/ghelling/src/packaging/1827948-python-spyking-circus/results/python-spyking-circus-doc-0.9.7-1.fc33.noarch.rpm /home/ghelling/src/packaging/1827948-python-spyking-circus/results/python3-spyking-circus-0.9.7-1.fc33.noarch.rpm
ERROR: Command failed: 
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 33 --setopt=deltarpm=False --allowerasing --disableplugin=local --disableplugin=spacewalk install /home/ghelling/src/packaging/1827948-python-spyking-circus/results/python-spyking-circus-doc-0.9.7-1.fc33.noarch.rpm /home/ghelling/src/packaging/1827948-python-spyking-circus/results/python3-spyking-circus-0.9.7-1.fc33.noarch.rpm



Rpmlint
-------
Checking: python3-spyking-circus-0.9.7-1.fc33.noarch.rpm
          python-spyking-circus-doc-0.9.7-1.fc33.noarch.rpm
          python-spyking-circus-0.9.7-1.fc33.src.rpm
python3-spyking-circus.noarch: W: spelling-error Summary(en_US) extracellular -> extra cellular, extra-cellular, extracurricular
python3-spyking-circus.noarch: W: spelling-error %description -l en_US datasets -> data sets, data-sets, databases
python3-spyking-circus.noarch: W: spelling-error %description -l en_US vitro -> vitriol
python3-spyking-circus.noarch: W: spelling-error %description -l en_US vivo -> viva, vino, vivid
python3-spyking-circus.noarch: W: spelling-error %description -l en_US hippocampus -> hippo campus, hippo-campus, hippopotamus
python3-spyking-circus.noarch: W: spelling-error %description -l en_US tetrodes -> bestrode, strode
python3-spyking-circus.noarch: W: spelling-error %description -l en_US optogenetic -> photogenic
python3-spyking-circus.noarch: E: useless-provides python-spyking-circus
python3-spyking-circus.noarch: E: useless-provides python38-spyking-circus
python3-spyking-circus.noarch: W: no-documentation
python3-spyking-circus.noarch: W: no-manual-page-for-binary circus-artefacts
python3-spyking-circus.noarch: W: no-manual-page-for-binary circus-folders
python3-spyking-circus.noarch: W: no-manual-page-for-binary circus-gui-matlab
python3-spyking-circus.noarch: W: no-manual-page-for-binary circus-gui-python
python3-spyking-circus.noarch: W: no-manual-page-for-binary circus-multi
python3-spyking-circus.noarch: W: no-manual-page-for-binary spyking-circus
python3-spyking-circus.noarch: W: no-manual-page-for-binary spyking-circus-launcher
python3-spyking-circus.noarch: W: no-manual-page-for-binary spyking-circus-subtask
python-spyking-circus.src: W: spelling-error Summary(en_US) extracellular -> extra cellular, extra-cellular, extracurricular
python-spyking-circus.src: W: spelling-error %description -l en_US datasets -> data sets, data-sets, databases
python-spyking-circus.src: W: spelling-error %description -l en_US vitro -> vitriol
python-spyking-circus.src: W: spelling-error %description -l en_US vivo -> viva, vino, vivid
python-spyking-circus.src: W: spelling-error %description -l en_US hippocampus -> hippo campus, hippo-campus, hippopotamus
python-spyking-circus.src: W: spelling-error %description -l en_US tetrodes -> bestrode, strode
python-spyking-circus.src: W: spelling-error %description -l en_US optogenetic -> photogenic
3 packages and 0 specfiles checked; 2 errors, 23 warnings.




Source checksums
----------------
https://files.pythonhosted.org/packages/source/s/spyking-circus/spyking-circus-0.9.7.tar.gz :
  CHECKSUM(SHA256) this package     : b0bce6f92fd38bf6e00cab2ae8f9d85bbe6b94cca9166bf8ce388a45a52d020d
  CHECKSUM(SHA256) upstream package : b0bce6f92fd38bf6e00cab2ae8f9d85bbe6b94cca9166bf8ce388a45a52d020d


Requires
--------
python3-spyking-circus (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.8dist(blosc)
    python3.8dist(colorama)
    python3.8dist(cython)
    python3.8dist(h5py)
    python3.8dist(matplotlib)
    python3.8dist(mpi4py)
    python3.8dist(numpy)
    python3.8dist(psutil)
    python3.8dist(scipy)
    python3.8dist(setuptools)
    python3.8dist(statsmodels)
    python3.8dist(tqdm)

python-spyking-circus-doc (rpmlib, GLIBC filtered):
    python3-spyking-circus



Provides
--------
python3-spyking-circus:
    python-spyking-circus
    python3-spyking-circus
    python3.8dist(spyking-circus)
    python38-spyking-circus
    python3dist(spyking-circus)

python-spyking-circus-doc:
    python-spyking-circus-doc



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1827948
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: fonts, Ocaml, R, PHP, Haskell, C/C++, SugarActivity, Java, Perl
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Ankur Sinha (FranciscoD) 2020-04-26 12:19:25 UTC
Thanks for the review. I've made the necessary updates:

- Remove mpi4py from setup.py so that it isn't picked up from the automated dep generator. I include the mpi4py bit explicitly for the mpich/openmpi meta packages.
- Move Readme.rst to %doc.
- I filed a bug for the automated "useless" provides: https://bugzilla.redhat.com/show_bug.cgi?id=1828041

- david08741: MPI packages are available, but since our builders are isolated virtual machines, we can't really test MPI on them. Upstream uses the same code for py2 and py3, but are considering dropping support for py2, so that bug should be fixed soon. https://github.com/spyking-circus/spyking-circus/issues/177

Updated spec/srpm:
Spec URL: https://ankursinha.fedorapeople.org/python-spyking-circus/python-spyking-circus.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-spyking-circus/python-spyking-circus-0.9.7-1.fc32.src.rpm


Greg, I'll review your package now. Thanks very much.

Comment 5 Ankur Sinha (FranciscoD) 2020-04-26 16:11:40 UTC
Note: Miro replied to the bug to say that the spurious provides are to be ignored on releases before F33. It's noted in the python guidelines now:
https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_the_python_provide_macro

Comment 6 greg.hellings 2020-04-27 06:13:43 UTC
Looks good to me!

Comment 7 greg.hellings 2020-04-27 06:29:23 UTC
For the sake of completeness I'll say: fedora-review still claims it can't install, but testing from a rawhide container the RPM installs just fine.

Comment 8 Ankur Sinha (FranciscoD) 2020-04-27 08:15:07 UTC
(In reply to greg.hellings from comment #7)
> For the sake of completeness I'll say: fedora-review still claims it can't
> install, but testing from a rawhide container the RPM installs just fine.

Thank you. I'd tested it out manually too, and it was OK. I'll double check why fedora-review is unhappy before building.

Comment 9 Gwyn Ciesla 2020-04-27 13:22:54 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-spyking-circus

Comment 10 Fedora Update System 2020-04-27 13:50:29 UTC
FEDORA-2020-14db45aad6 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-14db45aad6

Comment 11 Fedora Update System 2020-04-27 13:50:30 UTC
FEDORA-2020-f7314234a8 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-f7314234a8

Comment 12 Fedora Update System 2020-04-28 03:23:45 UTC
FEDORA-2020-f7314234a8 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-f7314234a8 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-f7314234a8

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2020-04-28 03:52:03 UTC
FEDORA-2020-14db45aad6 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-14db45aad6 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-14db45aad6

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2020-05-06 03:07:25 UTC
FEDORA-2020-14db45aad6 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 15 Fedora Update System 2020-05-06 04:29:37 UTC
FEDORA-2020-f7314234a8 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.